//Loading modules
var http = require('http');
var fs = require('fs');
var path = require('path');
var b = require('bonescript');

var inputPin = 'P8_19';
b.pinMode(inputPin, b.INPUT);

var lamp = 'P9_14';
b.pinMode(lamp, b.OUTPUT);

var tempSensor = 'P9_40';

var s;
var sys = require('sys');
var exec = require('child_process').exec;
function puts(error, stdout, stderr) { sys.puts(stdout); }

// Initialize the server on port 8888
var server = http.createServer(function (req, res) {
    // requesting files
    var file = '.'+((req.url=='/')?'/index.html':req.url);
    var fileExtension = path.extname(file);
    var contentType = 'text/html';
    // Uncoment if you want to add css to your web page

    if(fileExtension == '.css'){
        contentType = 'text/css';
    }
    else if(fileExtension == '.js'){
        contentType = 'text/javascript';
    }
    fs.exists(file, function(exists){
        if(exists){
            fs.readFile(file, function(error, content){
                if(!error){
                    // Page found, write content
                    res.writeHead(200,{'content-type':contentType});
                    res.end(content);
                }
            })
        }
        else{
            // Page not found
            res.writeHead(404);
            res.end('Page not found');
        }
    })
}).listen(8888);

// Loading socket io module
var io = require('socket.io').listen(server);

// When communication is established
io.on('connection', function (socket) {
    s = socket;
    socket.on('changeState', handleChangeState);
});

function interruptCallback(x) {
    var imageName = Math.random().toString(36).substring(7);
    exec("cd /var/lib/cloud9/home_automation/webcam; streamer -c /dev/video0 -o "+ imageName+".jpeg", puts);
    s.broadcast.emit("sensorsUpdateP", '{"newImage":"' + imageName + '.jpeg"}');
    s.emit("sensorsUpdateP", '{"newImage":"' + imageName + '.jpeg"}');
    console.log("Motion Detected");
}

function addTemperature(){
    b.analogRead(tempSensor, updateCurrentTemperature);
}

function updateCurrentTemperature(x){
    //console.log(x.value);
    var newTemp = ((1.8 * x.value * 100.0))-3.5;
    /* var temp = (x.value*1024.0)/9.31;*/
    console.log('Temp: ' + newTemp);
    s.broadcast.emit("updateTemperature", '{"temperature":"' + newTemp + '"}');
    s.emit("updateTemperature", '{"temperature":"' + newTemp + '"}');
}

// Change led state when a button is pressed
function handleChangeState(data) {
    var newData = JSON.parse(data);
    if(newData.state=='1'){
        b.digitalWrite(lamp, b.HIGH);
        console.log("Lamp: ON");
    }
    else if(newData.state=='0'){
          b.digitalWrite(lamp, b.LOW);
          console.log("Lamp: OFF");
    }

    else if(newData.state=='10'){
        b.attachInterrupt(inputPin, true, b.RISING, interruptCallback);
        setInterval(addTemperature, 1000);
    }
}

// Displaying a console message for user feedback
server.listen(console.log("Server Running ..."));
